"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.dispatch = exports.useEvent = void 0;
var react_1 = require("react");
var event_system_1 = require("./event-system");
function useEvent(type, onEvent) {
    (0, react_1.useEffect)(function () {
        if (!onEvent)
            return;
        event_system_1.eventSystem.addEventListener(type, onEvent);
        return function () {
            event_system_1.eventSystem.removeEventListener(type, onEvent);
        };
    }, [type, onEvent]);
    var dispatchEvent = (0, react_1.useCallback)(function (data) {
        dispatch(type, data);
    }, [type]);
    return dispatchEvent;
}
exports.useEvent = useEvent;
function dispatch(type, data) {
    var event = Object.assign(typeof Event === 'function' ? new Event(type) : { type: type }, data);
    event_system_1.eventSystem.dispatchEvent(event);
}
exports.dispatch = dispatch;
exports.default = useEvent;
//# sourceMappingURL=use-event.js.map